# == fovs / display screen v1.0  for Daedalus 3.11a ==

# EDIT THIS LIST HERE: ========================================
var fovs_list = [{ value: 40 , perFrame: 1.25 },
		 { value: 2 , perFrame: 1.25 }];
# =============================================================

var fov_node = props.globals.getNode("/sim/current-view/field-of-view", 1);
var fovs_list_node = props.globals.getNode("/sim/gui/dialogs/fovs-sequence", 1);
var fovs_value_node = fovs_list_node.getNode("fov-value", 1);
var fovs_perFrame_node = fovs_list_node.getNode("change-per-frame", 1);
fovs_list_node = fovs_list_node.getNode("list", 1);
fovs_position = 0;
var listbox_apply = func {
	var fov_split = split(" ",fovs_list_node.getValue());
	var fovi = pop(fov_split);
	var fovv = fov_split[0];
	if (fovv) {
		fov_node.setValue(fovv);
		fovs_value_node.setValue(fovv);
		fovs_perFrame_node.setValue(fovi);
		var done = 0;
		for (var i = 0 ; (!done and (i < size(fovs_list))) ; i += 1) {
			if ((fovv == fovs_list[i].value) and (fovi == fovs_list[i].perFrame)) {
				fovs_position = i;
#				print ("fov apply position= ",fovs_position);
				done = 1;
			}
		}
	} else {
		print ("fov apply error. ",size(fov_split)," ",fovv," ",fovi);
	}
}
var listbox_add = func {
	var fovv = fovs_value_node.getValue();
	var fovi = fovs_perFrame_node.getValue();
	if (fovv != nil and fovi != nil) {
		append(fovs_list, { value: fovv , perFrame: fovi });
#		print ("fov adding ",size(fovs_list)," ",fovv," ",fovi);
	} else {
		gui.popupTip("Can not add: Empty or invalid input",5);
		print ("fov add error.   ",fovv," ",fovi);
	}
}

var listbox_replace = func {
	var fovv = fovs_value_node.getValue();
	var fovi = fovs_perFrame_node.getValue();
	var fovlist_split = split(" ",fovs_list_node.getValue());
	var fovlist_i = pop(fovlist_split);
	var fovlist_v = fovlist_split[0];
	if (fovv != nil and fovi != nil) {
		var done = 0;
		for (var i = 0 ; (!done and (i < size(fovs_list))) ; i += 1) {
			if ((fovlist_v == fovs_list[i].value) and (fovlist_i == fovs_list[i].perFrame)) {
				fovs_position = i;
#				print ("fov position= ",fovs_position);
				done = 1;
			}
		}
		if (done) {
			fovs_list[fovs_position].value = fovv;
			fovs_list[fovs_position].perFrame = fovi;
		} else {
			print ("fov replace error: did not find position");
		}
	} else {
		print ("fov replace error. ",size(fovlist_split)," ",fovv," ",fovi);
	}
}

var fovs_dialog1 = nil;
var sequence = {
	showDialog: func {
		var name1 = "fovs-sequence";
		if (fovs_dialog1 != nil) {
			fgcommand("dialog-close", props.Node.new({ "dialog-name" : name1 }));
			fovs_dialog1 = nil;
			return;
		}

		fovs_dialog1 = gui.Widget.new();
		fovs_dialog1.set("layout", "vbox");
		fovs_dialog1.set("name", name1);
		fovs_dialog1.set("x", -40);
		fovs_dialog1.set("y", -240);

		# "window" titlebar
		titlebar = fovs_dialog1.addChild("group");
		titlebar.set("layout", "hbox");
		titlebar.addChild("empty").set("stretch", 1);
		titlebar.addChild("text").set("label", "Smooth FOV animation");
		titlebar.addChild("empty").set("stretch", 1);

		w = titlebar.addChild("button");
		w.set("pref-width", 16);
		w.set("pref-height", 14);
		w.set("legend", "");
		w.set("keynum", 27);
		w.set("border", 1);
		w.prop().getNode("binding[0]/command", 1).setValue("nasal");
		w.prop().getNode("binding[0]/script", 1).setValue("fovs.fovs_dialog1 = nil");
		w.prop().getNode("binding[1]/command", 1).setValue("dialog-close");

		fovs_dialog1.addChild("hrule").addChild("dummy");

		fovs_dialog1.addChild("text").set("label", "Current FOV  and  degrees-per-frame to change          ");
		var g = fovs_dialog1.addChild("group");
		g.set("layout", "hbox");
		var content = g.addChild("input");
		content.set("name", "input1");
		content.set("layout", "hbox");
		content.set("halign", "fill");
		content.set("label", "");
		content.set("default-padding", 0);
		content.set("pref-width", 80);
		content.set("editable", 1);
		content.set("live", 1);
		content.set("property", "/sim/gui/dialogs/fovs-sequence/fov-value");
		content.prop().getNode("binding[0]/command", 1).setValue("dialog-apply");
		content.prop().getNode("binding[0]/object-name", 1).setValue("input1");
		var content2 = g.addChild("input");
		content2.set("name", "input2");
		content2.set("layout", "hbox");
		content2.set("halign", "fill");
		content2.set("label", "");
		content2.set("default-padding", 0);
		content2.set("pref-width", 80);
		content2.set("editable", 1);
		content2.set("live", 1);
		content2.set("property", "/sim/gui/dialogs/fovs-sequence/change-per-frame");
		content2.prop().getNode("binding[0]/command", 1).setValue("dialog-apply");
		content2.prop().getNode("binding[0]/object-name", 1).setValue("input2");
		var box1 = g.addChild("button");
		box1.set("halign", "left");
		box1.set("label", "");
		box1.set("pref-width", 34);
		box1.set("pref-height", 28);
		box1.set("border", 2);
		box1.set("default", 1);
		box1.set("legend", "Set");
		box1.prop().getNode("binding[0]/command", 1).setValue("dialog-apply");
		box1.prop().getNode("binding[0]/object-name", 1).setValue("input1");
		box1.prop().getNode("binding[1]/command", 1).setValue("dialog-apply");
		box1.prop().getNode("binding[1]/object-name", 1).setValue("input2");
		box1.prop().getNode("binding[2]/command", 1).setValue("property-assign");
		box1.prop().getNode("binding[2]/property[0]", 1).setValue("/sim/current-view/field-of-view");
		box1.prop().getNode("binding[2]/property[1]", 1).setValue("/sim/gui/dialogs/fovs-sequence/fov-value");
		var box2 = g.addChild("button");
		box2.set("halign", "left");
		box2.set("label", "");
		box2.set("pref-width", 29);
		box2.set("pref-height", 28);
		box2.set("border", 2);
		box2.set("legend", "Add");
		box2.prop().getNode("binding[0]/command", 1).setValue("dialog-apply");
		box2.prop().getNode("binding[0]/object-name", 1).setValue("input1");
		box2.prop().getNode("binding[1]/command", 1).setValue("nasal");
		box2.prop().getNode("binding[1]/script", 1).setValue("fovs.listbox_add()");
		box2.prop().getNode("binding[2]/command", 1).setValue("dialog-update");
		box2.prop().getNode("binding[2]/object-name", 1).setValue("sequence-list");
		box2.prop().getNode("binding[3]/command", 1).setValue("nasal");
		box2.prop().getNode("binding[3]/script", 1).setValue("fovs.sequence.reloadDialog()");
		var box3 = g.addChild("button");
		box3.set("halign", "left");
		box3.set("label", "");
		box3.set("pref-width", 52);
		box3.set("pref-height", 28);
		box3.set("border", 2);
		box3.set("legend", "Replace");
		box3.prop().getNode("binding[0]/command", 1).setValue("dialog-apply");
		box3.prop().getNode("binding[0]/object-name", 1).setValue("input1");
		box3.prop().getNode("binding[1]/command", 1).setValue("nasal");
		box3.prop().getNode("binding[1]/script", 1).setValue("fovs.listbox_replace()");
		box3.prop().getNode("binding[2]/command", 1).setValue("dialog-update");
		box3.prop().getNode("binding[2]/object-name", 1).setValue("sequence-list");
		box3.prop().getNode("binding[3]/command", 1).setValue("nasal");
		box3.prop().getNode("binding[3]/script", 1).setValue("fovs.sequence.reloadDialog()");

		var a = fovs_dialog1.addChild("list");
		a.set("name", "sequence-list");
		a.set("pref-width", 327);
		a.set("pref-height", 160);
		a.set("slider", 18);
		a.set("property", "/sim/gui/dialogs/fovs-sequence/list");
		for (var i = 0 ; i < size(fovs_list) ; i += 1) {
			var fovv_in = fovs_list[i].value;
			var fovi_in = fovs_list[i].perFrame;
			a.set("value[" ~ i ~ "]", fovv_in ~ " "~ fovi_in);
		}
		a.prop().getNode("binding[0]/command", 1).setValue("dialog-apply");
		a.prop().getNode("binding[0]/object-name", 1).setValue("sequence-list");
		a.prop().getNode("binding[1]/command", 1).setValue("nasal");
		a.prop().getNode("binding[1]/script", 1).setValue("fovs.listbox_apply()");

		# finale
		fovs_dialog1.addChild("empty").set("pref-height", "3");
		fgcommand("dialog-new", fovs_dialog1.prop());
		gui.showDialog(name1);
	},
	reloadDialog: func {
		if (fovs_dialog1 != nil) {
			fgcommand("dialog-close", props.Node.new({ "dialog-name" : "fovs-sequence" }));
			fovs_dialog1 = nil;
			sequence.showDialog();
		}
	},
	advance: func {
		fovs_position += 1;
		if (fovs_position >= size(fovs_list)) {
			fovs_position = 0;
		}
		sequence.slide_fov(fovs_list[fovs_position].value,fovs_list[fovs_position].perFrame);
	},
	slide_fov: func (target_fov,target_perFrame) {
		var curr_fov = fov_node.getValue();
		if (abs(target_fov - curr_fov) < target_perFrame) {
			fov_node.setValue(target_fov);
		} else {
			if (curr_fov > target_fov) {
				fov_node.setValue(curr_fov - target_perFrame);
			} elsif (curr_fov < target_fov) {
				fov_node.setValue(curr_fov + target_perFrame);
			}
			settimer(func { sequence.slide_fov(target_fov, target_perFrame) }, 0.01) ;
		}
	},
};

